class Time
  def beginning_of_minute
    change(sec: 0)
  end

  def end_of_minute
    change(
      sec: 59,
      usec: Rational(999999999, 1000)
    )
  end

  def beginning_of_hour
    change(min: 0)
  end

  def end_of_hour
    change(
      :min => 59,
      :sec => 59,
      :usec => Rational(999999999, 1000)
    )
  end

  def all_minute
    beginning_of_minute..end_of_minute
  end

  def all_hour
    beginning_of_hour..end_of_hour
  end
end
